theory CompoTraces
imports Traces
begin

definition trace_module_comp :: "'a trace_module \<Rightarrow> 'a trace_module \<Rightarrow> 'a trace_module"
  where
  "trace_module_comp \<equiv> \<lambda> (trs1, sig1) (trs2, sig2) . let sig = asig_comp sig1 sig2 in 
    ({tr. forall (\<lambda> a . a \<in> (externals sig)) tr 
          \<and> filter (\<lambda> a. a \<in> actions sig1) tr \<in> trs1 
          \<and> filter (\<lambda> a. a \<in> actions sig2) tr \<in> trs2}, 
    sig)"

lemma comp_is_trace_module:
  fixes m1 m2
  shows "is_trace_module (trace_module_comp m1 m2)" 
  by (cases m1, cases m2, auto simp add:trace_module_comp_def is_trace_module_def)

lemma asig_comp_incl:
  fixes sig1 sig2
  shows "actions (asig_comp sig1 sig2) \<subseteq> actions sig1 \<union> actions sig2"
  by (simp add: actions_def asig_comp_def asig_inputs_def asig_outputs_def asig_internals_def, fastsimp)

end
